## landscape-client 24.02

=== Makefile ===
PYDOCTOR ?= pydoctor
TXT2MAN ?= txt2man
PYTHON ?= python3
SNAPCRAFT = SNAPCRAFT_BUILD_INFO=1 snapcraft
TRIAL ?= -m twisted.trial
TRIAL_ARGS ?=
PRE_COMMIT ?= $(HOME)/.local/bin/pre-commit

# PEP8 rules ignored:
# W503 https://www.flake8rules.com/rules/W503.html
# E203 Whitespace before ':' (enforced by Black)
PEP8_IGNORED = W503,E203

.PHONY: help
help:  ## Print help about available targets
	@grep -h -E '^[a-zA-Z0-9_-]+:.*?## .*$$' $(MAKEFILE_LIST) | sort | awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-20s\033[0m %s\n", $$1, $$2}'

.PHONY: depends
depends:
	sudo apt-get -y install python3-configobj python3-coverage python3-distutils-extra\
		python3-flake8 python3-mock python3-netifaces python3-pip python3-pycurl python3-twisted\
		net-tools
	pip install pre-commit
	$(PRE_COMMIT) install

all: build

.PHONY: build
build:
	$(PYTHON) setup.py build_ext -i

# trial3 does not support threading via `-j` at the moment
# so we ignore TRIAL_ARGS.
# TODO: Respect $TRIAL_ARGS once trial3 is fixed.
.PHONY: check
check: TRIAL_ARGS=
check: build
	PYTHONPATH=$(PYTHONPATH):$(CURDIR) LC_ALL=C $(PYTHON) $(TRIAL) --unclean-warnings $(TRIAL_ARGS) landscape

.PHONY: coverage
coverage:
	PYTHONPATH=$(PYTHONPATH):$(CURDIR) LC_ALL=C $(PYTHON) -m coverage run $(TRIAL) --unclean-warnings landscape
	PYTHONPATH=$(PYTHONPATH):$(CURDIR) LC_ALL=C $(PYTHON) -m coverage xml

.PHONY: lint
lint:
	$(PYTHON) -m flake8 --ignore $(PEP8_IGNORED) `find landscape -name \*.py`

.PHONY: pyflakes
pyflakes:
	-pyflakes `find landscape -name \*.py`

pre-commit:
	-pre-commit run -a

clean:
	-find landscape -name __pycache__ -exec rm -rf {} \;
	-find landscape -name \*.pyc -exec rm -f {} \;
	-rm -rf .coverage
	-rm -rf tags
	-rm -rf _trial_temp
	-rm -rf docs/api
	-rm -rf man/\*.1
	-rm -rf sdist

doc: docs/api/twisted/pickle
	mkdir -p docs/api
	${PYDOCTOR} --make-html --html-output docs/api --add-package landscape --extra-system=docs/api/twisted/pickle:twisted/

docs/api/twisted/pickle:
	mkdir -p docs/api/twisted
	-${PYDOCTOR} --make-html --html-output docs/api/twisted --add-package /usr/share/pyshared/twisted -o docs/api/twisted/pickle

manpages:
	LC_ALL=C ${TXT2MAN} -P Landscape -s 1 -t landscape-client < man/landscape-client.txt > man/landscape-client.1
	LC_ALL=C ${TXT2MAN} -P Landscape -s 1 -t landscape-config < man/landscape-config.txt > man/landscape-config.1
	LC_ALL=C ${TXT2MAN} -P Landscape -s 1 -t landscape-sysinfo < man/landscape-sysinfo.txt > man/landscape-sysinfo.1

MESSAGE_DIR = `pwd`/runclient-messages
LOG_FILE = `pwd`/runclient.log

.PHONY: freshdata
freshdata:
	-sudo rm -rf $(MESSAGE_DIR)
	-sudo mkdir $(MESSAGE_DIR)

.PHONY: run
run:
	-sudo ./landscape-client \
		-a onward -t "John's PC" \
		-u http://localhost:8080/message-system \
		-d $(MESSAGE_DIR) \
		--urgent-exchange-interval=5 \
		--log-level=debug \
		--ping-url=http://localhost:8081/ping \

.PHONY: freshrun
freshrun: freshdata run

.PHONY: tags
tags:
	-ctags --languages=python -R .

.PHONY: etags
etags:
	-etags --languages=python -R .

snap-install:
	sudo snap install --devmode landscape-client_0.1_amd64.snap
.PHONY: snap-install

snap-remote-build:
	snapcraft remote-build
.PHONY: snap-remote-build

snap-remove:
	sudo snap remove --purge landscape-client
.PHONY: snap-remove

snap-shell: snap-install
	sudo snap run --shell landscape-client.landscape-client
.PHONY: snap-shell

snap-debug:
	$(SNAPCRAFT) -v --debug
.PHONY: snap-debug

snap-clean: snap-remove
	$(SNAPCRAFT) clean
	-rm landscape-client_0.1_amd64.snap
.PHONY: snap-clean

snap:
	$(SNAPCRAFT)
.PHONY: snap

include Makefile.packaging

.DEFAULT_GOAL := help

=== snap-http/Makefile ===
.PHONY: test_snap
.ONESHELL:
test_snap:
	cd tests/integration/test_snap
	snapcraft --debug
	snap download hello-world --basename=hello-world

=== debian/changelog ===
landscape-client (24.02-0ubuntu5) noble; urgency=medium

  * d/p/2062561-fix-deb822-sources.patch: fix to include deb822 formatted
    sources when collecting source channels (LP: #2062561)

 -- Austin Nhung <austin.nhung@canonical.com>  Mon, 22 Apr 2024 15:42:34 -0600

landscape-client (24.02-0ubuntu4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 09:12:19 +0000

landscape-client (24.02-0ubuntu3) noble; urgency=medium

  * d/p/2057976-fix-ubuntu-pro-registration.patch: fix ubuntu pro info not
    being sent on registration exchange with Landscape Server (LP: #2057976)

 -- Spencer Runde <spencer.runde@canonical.com>  Thu, 14 Mar 2024 17:47:11 -0500

landscape-client (24.02-0ubuntu2) noble; urgency=medium

  * d/p/2055348-fix-expandvars-arb-exec.patch: fix potential arbitrary shell
    execution in landscape/lib/format.py:expandvars (LP: #2055348)

 -- Mitch Burton <mitch.burton@canonical.com>  Thu, 29 Feb 2024 10:23:23 -0800

landscape-client (24.02-0ubuntu1) noble; urgency=medium

  * New upstream release 24.02
    - d/control: added python3-dbus to Build-Depends
    - d/control: added python3-dbus to landscape-client Depends. Added
      python3-setuptools to landscape-common Depends. Removed lsb-base from
      landscape-common Depends.
    - d/control: use dephelper-compat 12, removed d/compat
    - d/patches: removed patches that have been applied upstream
    - d/watch: watch Github releases page instead of tags
    - snap-http: included new submodule under identical license
    - use dbus in shutdown manager instead of subprocess
    - improve messages about manager plugin configuration
    - add getting and settings snap configurations
    - read temperature from hwmon devices
    - add snapd device information to ComputerInfo message
    - add snap services management
    - d/landscape-common.postinst d/landscape-common.prerm: do not call
      update-motd when installing/removing landscape-sysinfo.wrapper
      (LP: #1855544)
    - Livepatch status reporting bug
    - bpickle: guard against negative string/bytestring lengths
    - Makefile: remove check2, depends2, and references to python2
    - add path for os-release inside a snap
    - computer title generation for zero-touch deployment on Core
    - user management on Core
    - deploy system user assertion to device
    - remote script execution for snaps

 -- Mitch Burton <mitch.burton@canonical.com>  Thu, 27 Feb 2024 16:46:56 -0800

=== debian/control ===
Source: landscape-client
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Landscape Team <landscape-team@canonical.com>
Build-Depends: debhelper-compat (= 12), po-debconf, libdistro-info-perl,
               dh-python, python3-dev, python3-distutils-extra,
               lsb-release, gawk, net-tools,
               python3-apt, python3-twisted, python3-configobj,
               python3-pycurl, python3-netifaces, python3-yaml,
               ubuntu-advantage-tools, locales-all, python3-dbus
Standards-Version: 4.4.0
Homepage: https://github.com/CanonicalLtd/landscape-client

Package: landscape-common
Architecture: any
Depends: ${python3:Depends}, ${misc:Depends}, ${extra:Depends},
         python3-twisted,
         python3-configobj,
         python3-apt,
         ca-certificates,
         python3-gdbm,
         python3-netifaces,
         lsb-release,
         adduser,
         bc,
         lshw,
         libpam-modules,
         python3-setuptools
Description: Landscape administration system client - Common files
 Landscape is a web-based tool for managing Ubuntu systems. This
 package is necessary if you want your machine to be managed in a
 Landscape account.
 .
 This package provides the core libraries, as well as the landscape-sysinfo
 command.  It also sets up the landscape user, landscape directories, and the
 hook that runs landscape-sysinfo on startup.

Package: landscape-client
Architecture: any
Depends: ${python3:Depends}, ${misc:Depends}, ${extra:Depends},
         ${shlibs:Depends},
         landscape-common (= ${binary:Version}),
         python3-pycurl,
	 python3-dbus
Description: Landscape administration system client
 Landscape is a web-based tool for managing Ubuntu systems. This
 package is necessary if you want your machine to be managed in a
 Landscape account.
 .
 This package provides the Landscape client and requires a Landscape account.

=== debian/rules ===
#!/usr/bin/make -f

export DH_ALWAYS_EXCLUDE=.git
export DH_VERBOSE = 1

package = landscape-client
root_dir = debian/tmp
SHAREDIR = /usr/share/landscape
LIBDIR = /usr/lib/landscape

%:
	dh $@ --with python3 --buildsystem=pybuild


override_dh_auto_build:
	sed -i -e "s/^DEBIAN_REVISION = \"\"/DEBIAN_REVISION = \"-$(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^-]*)-(.*),\2, p')\"/g" landscape/__init__.py
	dh_auto_build

override_dh_auto_install:
	dh_auto_install
	make -C apt-update
	install -D -o root -g root -m 755 debian/landscape-sysinfo.wrapper $(CURDIR)/$(root_dir)$(SHAREDIR)/landscape-sysinfo.wrapper
	install -D -o root -g root -m 755 apt-update/apt-update $(CURDIR)/$(root_dir)$(LIBDIR)/apt-update

override_dh_installsystemd:
	dh_installsystemd

override_dh_auto_test:
	HOME=$(shell mktemp -d) && make check

## landscape-client 24.08

=== Makefile ===
--- 
+++ 
@@ -17,11 +17,20 @@
 
 .PHONY: depends
 depends:
-	sudo apt-get -y install python3-configobj python3-coverage python3-distutils-extra\
+	sudo apt update && sudo apt-get -y install python3-configobj python3-coverage python3-distutils-extra\
 		python3-flake8 python3-mock python3-netifaces python3-pip python3-pycurl python3-twisted\
 		net-tools
+
+.PHONY: depends-dev
+depends-dev: depends
 	pip install pre-commit
 	$(PRE_COMMIT) install
+
+# -common seems a catch-22, but this is just a shortcut to
+# initialize user and dirs, some used through tests.
+.PHONY: depends-ci
+depends-ci: depends
+	sudo apt-get -y install landscape-common
 
 all: build
 
@@ -53,10 +62,12 @@
 pre-commit:
 	-pre-commit run -a
 
+.PHONY: clean
 clean:
 	-find landscape -name __pycache__ -exec rm -rf {} \;
 	-find landscape -name \*.pyc -exec rm -f {} \;
 	-rm -rf .coverage
+	-rm -rf coverage
 	-rm -rf tags
 	-rm -rf _trial_temp
 	-rm -rf docs/api
@@ -106,7 +117,8 @@
 	-etags --languages=python -R .
 
 snap-install:
-	sudo snap install --devmode landscape-client_0.1_amd64.snap
+	$(eval VERSION=$(shell yq ".version" snap/snapcraft.yaml))
+	sudo snap install --devmode landscape-client_$(VERSION)_amd64.snap
 .PHONY: snap-install
 
 snap-remote-build:
@@ -126,14 +138,23 @@
 .PHONY: snap-debug
 
 snap-clean: snap-remove
+	$(eval VERSION=$(shell yq ".version" snap/snapcraft.yaml))
 	$(SNAPCRAFT) clean
-	-rm landscape-client_0.1_amd64.snap
+	-rm landscape-client_$(VERSION)_amd64.snap
 .PHONY: snap-clean
 
 snap:
 	$(SNAPCRAFT)
 .PHONY: snap
 
+# TICS expects coverage info to be in ./coverage/.coverage
+.PHONY: prepare-tics-analysis
+prepare-tics-analysis: depends-ci coverage
+	sudo apt install pylint
+	mkdir -p coverage
+	cp .coverage ./coverage/.coverage
+	cp coverage.xml ./coverage/coverage.xml
+
 include Makefile.packaging
 
 .DEFAULT_GOAL := help

=== debian/changelog ===
landscape-client (24.08-0ubuntu2.1) oracular; urgency=medium

  * d/control: add python3-yaml dependency to landscape-client (LP: #2084586)

 -- Mitch Burton <mitch.burton@canonical.com>  Tue, 15 Oct 2024 16:55:23 -0700

landscape-client (24.08-0ubuntu2) oracular; urgency=medium

  * d/t/control: add unit tests

 -- Mitch Burton <mitch.burton@canonical.com>  Wed, 28 Aug 2024 14:39:53 -0700

landscape-client (24.08-0ubuntu1) oracular; urgency=medium

  * New upstream release 24.08
    - d/landscape-sysinfo.wrapper: remove system exit
    - d/patches: remove patches that have been applied upstream
    - feat: added landscape-config flag to skip sending a registration request
    - feat: use snap set to change snap configurations
    - fix: merge SnapMonitor into SnapManger to fix config reporting permissions
      registration
  * d/p/fix-landscape-client-manpage.patch: fix indentation in landscape-client
    manpage

 -- Mitch Burton <mitch.burton@canonical.com>  Mon, 12 Aug 2024 13:50:28 -0700

landscape-client (24.02-0ubuntu9) oracular; urgency=medium

  * d/landscape-sysinfo.wrapper: fix 'cores' variable to CORES in message-
    of-the-day load threshold calculation (LP: #2066983)

 -- Spencer Runde <spencer.runde@canonical.com>  Tue, 28 May 2024 14:19:00 -0500

landscape-client (24.02-0ubuntu8) oracular; urgency=medium

  * d/p/2068050-fix-pycurl-error-string-test: Fix difference in pycurl error
    string upon certificate validation failured (LP: #2068050)

 -- Mitch Burton <mitch.burton@canonical.com>  Wed, 12 Jun 2024 14:51:00 -0700

landscape-client (24.02-0ubuntu7) oracular; urgency=medium

  * d/p/add-non-filtered-interfaces-to-the-api-response.patch: include
    all non-filtered network interfaces that have a valid MAC address
    in the API response. (LP: #2052834)

 -- Ghadi Elie Rahme <ghadi.rahme@canonical.com>  Tue, 04 Jun 2024 13:56:24 +0000

landscape-client (24.02-0ubuntu6) oracular; urgency=medium

  * d/t/control, d/t/smoke: add smoke test

 -- Mitch Burton <mitch.burton@canonical.com>  Mon, 03 Jun 2024 15:16:13 -0700

=== debian/tests/control ===
Tests: smoke
Restrictions: allow-stderr, needs-sudo, superficial

Test-Command: HOME=$(mktemp -d) make check
Depends: @builddeps@
Restrictions: allow-stderr
Features: test-name=unit

## landscape-client 24.12

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 TXT2MAN ?= txt2man
 PYTHON ?= python3
 SNAPCRAFT = SNAPCRAFT_BUILD_INFO=1 snapcraft
-TRIAL ?= -m twisted.trial
+TRIAL ?= -m landscape.lib.run_tests
 TRIAL_ARGS ?=
 PRE_COMMIT ?= $(HOME)/.local/bin/pre-commit

=== debian/changelog ===
landscape-client (24.12-0ubuntu2.2) plucky; urgency=medium

  * d/p/fix-apt-source-file-management.patch: restore .list and .sources files
    when a repo profile is disassociated (LP: #2087852)

 -- Mitch Burton <mitch.burton@canonical.com>  Fri, 13 Jun 2025 09:39:22 -0700

landscape-client (24.12-0ubuntu2.1) plucky; urgency=medium

  * d/p/package-reporter-high-cpu.patch: backport fix to reduce CPU usage of
    package-reporter by avoiding creating Origin objects from the Python
    apt package. (LP: #2099283)

 -- Jan-Yaeger Dhillon <jan.dhillon@canonical.com>  Tue, 01 Apr 2025 01:07:36 +0000

landscape-client (24.12-0ubuntu2) plucky; urgency=medium

  [ Bryan Fraschetti ]
  * d/p/2087852-feat-manage-ubuntu-sources-glob.patch: include DEB822 formatted sources
    when managing apt sources by regex matching .sources files (LP: #2087852)

  [ Mitch Burton ]
  * Fix FTBFS (LP: #2106263)
    - d/p/unittest-makeSuite-deprecation.patch: fix tests on python versions
      where unittest.makeSuite has been removed
    - d/rules: don't make root:root owner of installed executables
    - d/tests/control: set environment variables for autopkgtest user and
      build environment
    - d/p/allow-http-proxy-in-tests.patch: fix tests by making them
      insensitive to http/https proxy environment variables

 -- Mitch Burton <mitch.burton@canonical.com>  Wed, 26 Mar 2025 17:47:28 -0700

landscape-client (24.12-0ubuntu1) plucky; urgency=medium

  * New upstream release 24.12
    - d/patches: remove patches that have been applied upstream
      - fix-plucky-tests.patch
    - d/rules: add landscape user workaround
    - fix: improve output for is-registered flag
    - fix: fixed monitor-only flag for false values
    - fix: surface SSL certificates
    - fix: updated motd
    - fix: added plucky tests
    - fix: get ubuntu pro info on snaps
    - feat: added landscape-config --silent flag
    - move livepatch to manager instead of monitor plugin
    - fix: add date and hash fields to repository tests
    - fix: ensure preferences.d exists
    - fix: patch missing Trial addDuration method
    - updated snapcraft.yaml
    - refactor: use synchronous message exchange for landscape-config
    - fix: ensure homedir and broker.bpickle are owned by Landscape
    - fix: added manage-sources-list-d flag 
    - refactor: optparse to argparse
    - fix: parse livepatch status
    - fix: landscape-config uses ssl_public_key
    - fix: registration with landscape-client.config on snap
    - feat: add cloud-init message
    - fix: process full server response
    - fix: prevent creation of clones after reverting to previous snap
    - feat: add installation_request_id parameter to registration
    - fix: TiOBE TiCS workflow
    - fix: set insecure id during registration 

 -- Justin Kim <justin.kim@canonical.com>  Mon, 9 Dec 2024 15:29:26 -0800

landscape-client (24.08-0ubuntu3) plucky; urgency=medium

  * d/control: add python3-yaml dependency to landscape-client (LP: #2084586)
  * d/p/fix-plucky-tests.patch: fix unit tests on Twisted >= 24.10

 -- Mitch Burton <mitch.burton@canonical.com>  Fri, 29 Nov 2024 14:18:44 -0800

=== debian/control ===
--- 
+++ 
@@ -42,7 +42,8 @@
          ${shlibs:Depends},
          landscape-common (= ${binary:Version}),
          python3-pycurl,
-	 python3-dbus
+	 python3-dbus,
+	 python3-yaml
 Description: Landscape administration system client
  Landscape is a web-based tool for managing Ubuntu systems. This
  package is necessary if you want your machine to be managed in a

=== debian/rules ===
--- 
+++ 
@@ -19,11 +19,11 @@
 override_dh_auto_install:
 	dh_auto_install
 	make -C apt-update
-	install -D -o root -g root -m 755 debian/landscape-sysinfo.wrapper $(CURDIR)/$(root_dir)$(SHAREDIR)/landscape-sysinfo.wrapper
-	install -D -o root -g root -m 755 apt-update/apt-update $(CURDIR)/$(root_dir)$(LIBDIR)/apt-update
+	install -D -m 755 debian/landscape-sysinfo.wrapper $(CURDIR)/$(root_dir)$(SHAREDIR)/landscape-sysinfo.wrapper
+	install -D -m 755 apt-update/apt-update $(CURDIR)/$(root_dir)$(LIBDIR)/apt-update
 
 override_dh_installsystemd:
 	dh_installsystemd
 
 override_dh_auto_test:
-	HOME=$(shell mktemp -d) && make check
+	HOME=$(shell mktemp -d) LANDSCAPE_CLIENT_USER=$(shell whoami) LANDSCAPE_CLIENT_BUILDING=1 make check
